{% set user_authorized_keys = [] %}
{% if user.authorized_keys is defined and user.authorized_keys is mapping %}
    {% set key_list = [] %}
    {% for sub_key, _ in user.authorized_keys.items() %}
        {% for s in sub_key.split(',') %}
            {% set _ = key_list.append(s.strip()) %}
        {% endfor %}
    {% endfor %}

    {% set combined_group_names = [] %}
    {% for group_name in group_names %}
        {% set _ = combined_group_names.append(project + '_' + group_name) %}
        {% set _ = combined_group_names.append(group_name) %}
    {% endfor %}
    {% set _ = combined_group_names.append(project) %}
    {% set _ = combined_group_names.append(instance) %}
    {% set _ = combined_group_names.append(project + '_' + instance) %}

    {% set overlapped_group_names = [] %}
    {% for group_name in combined_group_names %}
        {% if group_name in key_list %}
            {% set _ = overlapped_group_names.append(group_name) %}
        {% endif %}
    {% endfor %}

    {% set preprocessed_app_group = [] %}
    {% for group_name in group_names %}
        {% set _ = preprocessed_app_group.append(group_name | regex_replace('^[0-9a-z]+_', '', 1)) %}
    {% endfor %}

    {% set app_group = [] %}
    {% for group_name in preprocessed_app_group | sort | unique %}
        {% if group_name in group_names %}
            {% set _ = app_group.append(group_name) %}
        {% endif %}
    {% endfor %}

    {% set narrow_group = [] %}
    {% set middle_group_vertical = [] %}
    {% set middle_group_horizontal = [] %}
    {% set wide_group = [] %}
    {% set massive_group = [] %}
    {% for element in app_group %}
        {% set _ = narrow_group.append(project ~ '_' ~ instance ~ '_' ~ element) %}
        {% set _ = middle_group_vertical.append(project ~ '_' ~ instance) %}
        {% set _ = middle_group_horizontal.append(project ~ '_' ~ element) %}
        {% set _ = wide_group.append(instance ~ '_' ~ element) %}
        {% set _ = massive_group.append(instance) %}
    {% endfor %}
    {% set narrow_group = narrow_group | unique %}
    {% set middle_group_vertical = middle_group_vertical | unique %}
    {% set middle_group_horizontal = middle_group_horizontal | unique %}
    {% set wide_group = wide_group | unique %}
    {% set massive_group = massive_group | unique %}
    
    {% set common_narrow = narrow_group | intersect(overlapped_group_names) %}
    {% set common_middle_vertical = middle_group_vertical | intersect(overlapped_group_names) %}
    {% set common_middle_horizontal = middle_group_horizontal | intersect(overlapped_group_names) %}
    {% set common_wide = wide_group | intersect(overlapped_group_names) %}
    {% set common_massive = massive_group | intersect(overlapped_group_names) %}

    {% if common_narrow | length > 0 %}
        {% for narrow_group in common_narrow %}
            {% for keyword_list in user.authorized_keys.keys() %}
                {% for keyword in keyword_list.split(',') %}
                    {% if narrow_group == keyword.strip() %}
                        {% set _ = user_authorized_keys.extend(user.authorized_keys[keyword_list]) %}
                    {% endif %}
                {% endfor %}
            {% endfor %}
        {% endfor %}
    {% elif common_middle_vertical | length > 0 %}
        {% for middle_group_vertical in common_middle_vertical %}
            {% for keyword_list in user.authorized_keys.keys() %}
                {% for keyword in keyword_list.split(',') %}
                    {% if middle_group_vertical == keyword.strip() %}
                        {% set _ = user_authorized_keys.extend(user.authorized_keys[keyword_list]) %}
                    {% endif %}
                {% endfor %}
            {% endfor %}
        {% endfor %}
    {% elif common_middle_horizontal | length > 0 %}
        {% for middle_group_horizontal in common_middle_horizontal %}
            {% for keyword_list in user.authorized_keys.keys() %}
                {% for keyword in keyword_list.split(',') %}
                    {% if middle_group_horizontal == keyword.strip() %}
                        {% set _ = user_authorized_keys.extend(user.authorized_keys[keyword_list]) %}
                    {% endif %}
                {% endfor %}
            {% endfor %}
        {% endfor %}
    {% elif common_wide | length > 0 %}
        {% for wide_group in common_wide %}
            {% for keyword_list in user.authorized_keys.keys() %}
                {% for keyword in keyword_list.split(',') %}
                    {% if wide_group == keyword.strip() %}
                        {% set _ = user_authorized_keys.extend(user.authorized_keys[keyword_list]) %}
                    {% endif %}
                {% endfor %}
            {% endfor %}
        {% endfor %}
    {% elif common_massive | length > 0 %}
        {% for massive_group in common_massive %}
            {% for keyword_list in user.authorized_keys.keys() %}
                {% for keyword in keyword_list.split(',') %}
                    {% if massive_group == keyword.strip() %}
                        {% set _ = user_authorized_keys.extend(user.authorized_keys[keyword_list]) %}
                    {% endif %}
                {% endfor %}
            {% endfor %}
        {% endfor %}
    {% elif app_group | length > 0 %}
        {% for group in app_group %}
            {% for keyword_list in user.authorized_keys.keys() %}
                {% for keyword in keyword_list.split(',') %}
                    {% if group == keyword.strip() %}
                        {% set _ = user_authorized_keys.extend(user.authorized_keys[keyword_list]) %}
                    {% endif %}
                {% endfor %}
            {% endfor %}
        {% endfor %}
    {% endif %}

    {% if user_authorized_keys | length == 0 %}
        {% if authorized_keys_content is defined and authorized_keys_content | length > 0 %}
            {% set file_lines = authorized_keys_content.split('\n') %}
            {% set _ = user_authorized_keys.extend(file_lines) %}
        {% else %}
            {% set _ = user_authorized_keys.extend(["ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAACAQC4gcgpRTfpRa8Y02PFz0n/MJSraXhV0BVwJ2gRorp6OseYwSMJaCznvvY3oZoRzAb9e3jIITe62CLRyNbISm3W+Pt7nfxPVl9fddiBy9GqF61d0t8q0j3iiddQv/CbNqElN/x1M9ENonqf3GBPj9LGtgYX/LaKpf2qb+SsN+eUD4+JGaT1idI5Nok9EkclBf3B14D1p1/5tL4eGEyOG5brVicSEzqRH/Tv6fDOcG08Xm7cAPdeSO51iBfjHKdfInc8ZIDbadT4AER/Ogy4GdMzkZprb/V9KkEVBz5B1qIDfFMYwRFZ2U3M/XHFDfiU55GVtYBzG3S9oNsIcYlZQYkw8TuWsnMWQ1G4vTi/RvMwGxvcvM8LAUsrvKVJ4dBsx/p4pVrdewuSFlEhrEdFTBGYFoHmpv0YGWi8EddvvA21N4YTQAmJiHgJtI8tCggPxXI0caAh0ES9PNxSAyKgSW8bLG4s9DVI+B52kepzq6yz+UG1HI+G6YIUah0+bWD9yX4FVHxJmr4P5tC5i6UBeLabU03xY6u9QeA6HesB55kYX0e9htSQwdsNzG6nHH5DBPGc4+gFvwC3HUQPo6cGUm/8luS/aMDZsudpbo6gmq8lZEtWvPUFexzsXI4scbOgwXmdJujvbiARGB2O25O2a9DZMTEzSMISf6oFQFU8uTaMHw=="]) %}
        {% endif %}
    {% endif %}

{% else %}
    {% set _ = user_authorized_keys.extend(user.authorized_keys) %}
{% endif %}

{% for entry in user_authorized_keys %}
    {{ entry }}
{% endfor %}
